<script src="./Script.js"></script>

<template>
  <div v-if="attribute.data_type_id">
    <template v-if="attribute.data_type_id == isText">
      <s-input-text
        :data-vv-scope="scope"
        v-model="attribute.attribute_value"
        :id="attribute.attribute_code"
        :name="attribute.attribute_code"
        v-validate="{ required: attribute.is_required ? true : false, max: 250 }"
        @keyup="changeDataInputType(attribute.attribute_code)"
      ></s-input-text>
    </template>

    <template v-if="attribute.data_type_id == isDate">
      <s-input-date
        :data-vv-scope="scope"
        v-model="attribute.attribute_value"
        v-validate="{ required: attribute.is_required ? true : false }"
        :id="attribute.attribute_code"
        :name="attribute.attribute_code"
        @change="changeDataInputType(attribute.attribute_code)"
      ></s-input-date>
    </template>

    <template v-if="attribute.data_type_id == isDateTime">
      <s-input-date-time
        :data-vv-scope="scope"
        v-model="attribute.attribute_value"
        v-validate="{ required: attribute.is_required ? true : false }"
        :id="attribute.attribute_code"
        :name="attribute.attribute_code"
        @change="changeDataInputType(attribute.attribute_code)"
      ></s-input-date-time>
    </template>

    <template v-if="attribute.data_type_id == isPhone">
      <s-input-phone
        :data-vv-scope="scope"
        v-model="attribute.attribute_value"
        v-validate="{ required: attribute.is_required ? true : false, regex: helpers.regexPhone() }"
        :id="attribute.attribute_code"
        :name="attribute.attribute_code"
        @keyup="changeDataInputType(attribute.attribute_code)"
      ></s-input-phone>
    </template>

    <template v-if="attribute.data_type_id == isEmail">
      <s-input-email
        :data-vv-scope="scope"
        v-model="attribute.attribute_value"
        v-validate="{ required: attribute.is_required ? true : false, regex: helpers.regexEmail(), max: 250 }"
        :id="attribute.attribute_code"
        :name="attribute.attribute_code"
        @keyup="changeDataInputType(attribute.attribute_code)"
      ></s-input-email>
    </template>

    <template v-if="attribute.data_type_id == isNumber">
      <s-input-number-custom
        :data-vv-scope="scope"
        v-model="attribute.attribute_value"
        v-validate="{ required: attribute.is_required ? true : false }"
        :id="attribute.attribute_code"
        :name="attribute.attribute_code"
        @keyup="changeDataInputType(attribute.attribute_code)"
      ></s-input-number-custom>
    </template>

    <template v-if="attribute.data_type_id == isPrice">
      <s-input-number-custom
        :is_decimal="false"
        :data-vv-scope="scope"
        v-model="attribute.attribute_value"
        v-validate="{ required: attribute.is_required ? true : false }"
        :id="attribute.attribute_code"
        :name="attribute.attribute_code"
        @keyup="changeDataInputType(attribute.attribute_code)"
      ></s-input-number-custom>
    </template>

    <template v-if="attribute.data_type_id == isSelect">
      <s-select
        :data-vv-scope="scope"
        v-model="attribute.attribute_value"
        v-validate="{ required: attribute.is_required ? true : false }"
        :id="attribute.attribute_code"
        :name="attribute.attribute_code"
        :data="attribute.attribute_options"
        :label="'option_value'"
        @change="changeDataInputType(attribute.attribute_code)"
      ></s-select>
    </template>

    <template v-if="attribute.data_type_id == isSelectFind">
      <s-select-search
        :data-vv-scope="scope"
        v-model.number="attribute.attribute_value"
        v-validate="{ required: attribute.is_required ? true : false }"
        :id="attribute.attribute_code"
        :name="attribute.attribute_code"
        :data="attribute.attribute_options"
        :label="'option_value'"
        @change="changeDataInputType(attribute.attribute_code)"
      ></s-select-search>
    </template>

    <template v-if="attribute.data_type_id == isMultipleSelect">
      <s-select-multiple
        :data-vv-scope="scope"
        v-model="attribute.attribute_value"
        v-validate="{ required: attribute.is_required ? true : false }"
        :id="attribute.attribute_code"
        :name="attribute.attribute_code"
        :data="attribute.attribute_options"
        :label="'option_value'"
        @change="changeDataInputType(attribute.attribute_code)"
      ></s-select-multiple>
    </template>

    <template v-if="attribute.data_type_id == isTag">
      <s-tags
        :data-vv-scope="scope"
        v-model="attribute.attribute_value"
        v-validate="{ required: attribute.is_required ? true : false }"
        :id="attribute.attribute_code"
        :name="attribute.attribute_code"
        :data="attribute.attribute_options"
        :label="'option_value'"
        @change="changeDataInputType(attribute.attribute_code)"
      ></s-tags>
    </template>

    <template v-if="attribute.data_type_id == isTextArea">
      <s-textarea
        :data-vv-scope="scope"
        v-model="attribute.attribute_value"
        v-validate="{ required: attribute.is_required ? true : false, max: 1025 }"
        :id="attribute.attribute_code"
        :name="attribute.attribute_code"
        @keyup="changeDataInputType(attribute.attribute_code)"
      ></s-textarea>
    </template>

    <template v-if="attribute.data_type_id == isCheckboxMultiple">
      <s-checkbox-multiple
        :data-vv-scope="scope"
        v-model="attribute.attribute_value"
        v-validate="{ required: attribute.is_required ? true : false }"
        :id="attribute.attribute_code"
        :name="attribute.attribute_code"
        :data="attribute.attribute_options"
        :label="'option_value'"
        @keyup="changeDataInputType(attribute.attribute_code)"
      ></s-checkbox-multiple>
    </template>

    <template v-if="attribute.data_type_id == isRadio">
      <s-radio-multiple
        :data-vv-scope="scope"
        :col="'col-md-6'"
        v-model="attribute.attribute_value"
        :label="'option_value'"
        v-validate="{ required: attribute.is_required ? true : false }"
        :id="attribute.attribute_code"
        :name="attribute.attribute_code"
        :data="attribute.attribute_options"
        @keyup="changeDataInputType(attribute.attribute_code)"
      ></s-radio-multiple>
    </template>

    <template v-if="attribute.data_type_id == isUser">
      <v-select
        v-model="attribute.attribute_value"
        label="full_name"
        :options="listUsers"
        index="id"
        :id="attribute.attribute_code"
        :name="attribute.attribute_code"
        :data-vv-scope="scope"
        v-validate="{ required: attribute.is_required ? true : false }"
        @change="changeDataInputType(attribute.attribute_code)"
      >
        <template slot="option" slot-scope="option">
          <b>{{ option.full_name | truncateWords }}</b>
          <br />
          {{ option.email | truncateWords }}
        </template>
      </v-select>
    </template>

    <template v-if="attribute.data_type_id == isUserMultiple">
      <v-select
        v-model="attribute.attribute_value"
        label="full_name"
        :options="listUsers"
        index="id"
        multiple
        :id="attribute.attribute_code"
        :name="attribute.attribute_code"
        :data-vv-scope="scope"
        v-validate="{ required: attribute.is_required ? true : false }"
        @change="changeDataInputType(attribute.attribute_code)"
      >
        <template slot="option" slot-scope="option">
          <b>{{ option.full_name | truncateWords }}</b>
          <br />
          {{ option.email | truncateWords }}
        </template>
      </v-select>
    </template>
    <div
      class="form-control-feedback m--font-danger"
      v-if="server_errors != '' && server_errors[attribute.attribute_code]"
    >
      <template
        v-if="server_errors[attribute.attribute_code].is_unique"
      >{{ attribute.attribute_name }} bị trùng.</template>
      <template
        v-else-if="server_errors[attribute.attribute_code].is_required"
      >Không được để trống trường này.</template>
      <template v-else-if="server_errors[attribute.attribute_code].is_max">
        <template v-if="attribute.data_type_id === isTextArea">Giới hạn 1025 ký tự.</template>
        <template v-else>Giới hạn 250 ký tự.</template>
      </template>
      <template
        v-else-if="server_errors[attribute.attribute_code].is_phone || server_errors[attribute.attribute_code].is_email"
      >
        Định dạng
        <span class="text-lowercase">{{ attribute.attribute_name }}</span> không đúng.
      </template>
      <template
        v-else-if="server_errors[attribute.attribute_code].attribute_not_update ||
         server_errors[attribute.attribute_code].attribute_option_not_exist"
      >
        Dữ liệu đã thay đổi vui lòng bấm
        <a
          class="m-link m-link--primary nt-link"
          href="#"
          @click.prevent="reloadGetListAttribute()"
        >vào đây</a> để tải lại.
      </template>
      <template
        v-else-if="server_errors[attribute.attribute_code].not_exist"
      >{{ attribute.attribute_name }} đã bị xóa, vui lòng tải lại trang.</template>
      <template v-else>{{ server_errors[attribute.attribute_code][0] }}</template>
    </div>

    <div
      class="form-control-feedback m--font-danger"
      v-else-if="errors.has(scope + '.' + attribute.attribute_code)"
    >
      <div v-for="(error, indexA) in errors.items" :key="indexA">
        <template v-if="errors.items.length > 0 && scope === error.scope">
          <template
            v-if="attribute.attribute_code == error.field && error.rule == 'required'"
          >Không được để trống trường này.</template>
          <template v-if="attribute.attribute_code == error.field && error.rule == 'max'">
            <template v-if=" attribute.data_type_id == isPrice">Giới hạn 20 ký tự.</template>
            <template v-else-if=" attribute.data_type_id == isTextArea">Giới hạn 1025 ký tự.</template>
            <template v-else>Giới hạn 250 ký tự.</template>
          </template>

          <template v-if="attribute.attribute_code == error.field && error.rule == 'regex'">
            Định dạng
            <span class="text-lowercase">{{ attribute.attribute_name }}</span> không đúng.
          </template>

          <template
            v-if="attribute.attribute_code == error.field && error.rule == 'numeric'"
          >Giá chỉ được điền số >= 0.</template>
        </template>
      </div>
    </div>

    <div class="form-control-feedback m--font-danger" v-else>&nbsp;</div>
  </div>
</template>
